﻿namespace UltraGridResetCellAppearance
{
    using System;
    using System.Collections.Generic;
    using System.Data;
    using System.Drawing;
    using System.Windows.Forms;

    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        private Infragistics.Win.Appearance selectedCellAppearance = new Infragistics.Win.Appearance();
        private HashSet<UltraGridCell> changedCells = new HashSet<UltraGridCell>();

        public Form1()
        {
            this.InitializeComponent();
            this.ugGrid.DataSource = this.GetDataSet(10);

            this.selectedCellAppearance.ForeColor = Color.White;
            this.selectedCellAppearance.BackColor = Color.Black;
        }

        private void ButtonSet_Click(object sender, EventArgs e)
        {
            foreach (UltraGridRow xRow in this.ugGrid.Rows)
            {
                foreach (UltraGridCell xCell in xRow.Cells)
                {
                    if (this.ugGrid.Selected.Cells.Contains(xCell))
                    {
                        xCell.Appearance = this.selectedCellAppearance;
                        this.changedCells.Add(xCell);
                    }
                }
            }
        }

        private void ButtonClear_Click(object sender, EventArgs e)
        {
            foreach (UltraGridCell xCell in this.changedCells)
            {
                xCell.Appearance.Reset();
            }

            this.changedCells.Clear();
        }

        private DataSet GetDataSet(int rowsCount)
        {
            DataSet dataSet = new DataSet();
            DataTable dataTable = dataSet.Tables.Add();

            dataTable.Columns.Add("Id", typeof(int));
            dataTable.Columns.Add("Name", typeof(string));

            for (int row = 0; row < rowsCount; row++)
            {
                dataTable.Rows.Add(new object[] { row, "Row# " + row });
            }

            return dataSet;
        }
    }
}
